# PF

## Introductie

PF is de opvolger van Purefaçade.
Purefaçade maakte het eenvoudig mogelijk om data uit de Pure webservices beschikbaar te krijgen in de website,
in de vorm van HTML, RSS of vCards.
Purefaçade bood veel mogelijkheden.
Een aantal ervan kunnen worden overgenomen door de nieuwe Pure Portal.
Veel opties werden in de praktijk niet gebruikt.
Sommige opties waren nuttig toen Purefaçade gebouwd werd, maar zijn dat nu niet meer.
Caching, bijvoorbeeld, was in het begin nodig omdat Pure heel traag was.
Nu zit caching meer in de weg dan dat het nuttig is.
Pure heeft een eenvoudiger API gekregen, wat het parsen van de output van de webservices zeer sterk heeft vereenvoudigd.
PF gebruikt de nieuwe API van Pure webservices.
Verder wordt nu de APA-rendering van Pure zelf gebruikt, wat zeer veel programmatuur scheelt.
PF is daarom een systeem dat maar een paar dingen kan, en met veel minder opties.

Het volgende sequence-diagram beschijft de werking:

![UML Sequence Diagram](sequence.png)

Toelichting: iemand bezoekt een pagina in de website met content uit Pure.
Er wordt dan een verzoek gedaan aan PF om bijvoorbeeld een RSS feed van recente publicaties van een faculteit.
PF roept dan een of meer keer Pure Webservices aan, die de data weer uit de Pure database haalt.
Wanneer alle data verzameld is, verwerkt PF dat en levert het af als één document, bijvoorbeeld dus RSS.
Drupal verwerkt de gegevens in een webpagina en levert die aan de bezoeker.

## Beperkte toegang

Toegang tot de service kan beperkt zijn om persoonsdata af te schermen en om te voorkomen dat getoonde gegevens in Webwijs worden aangepast.

## Features

- Series, zoals CentER Discussion Paper-series, voor een jaar, gesorteerd op afnemend volume als RSS
- UUID van wetenschapper gegeven de mailnaam
- Data medewerkers t.b.v. Experts & Expertise (Webwijs)

## Gebruik

Alle getoonde URLs en links in de voorbeelden zijn herschreven naar de omgeving waar PF draait.

### GET /organisations/organisation;{id=[Id] | uuid=[uuid]}/projects?rendering=[rendering]

RSS van 'Active' projecten van de organisatie en alle suborganisaties,
gesorteerd op afnemende startdatum

Geef OF het ID van de organisatie mee als ';id=[id]' OF de UUID als ';uuid=[uuid]'.

Rendering bepaalt hoe de descriptioner als HTML uit komt.
Rendering is niet verplicht op te geven.
Default rendering = 'short'.
Er zijn heel veel mogelijke waarden voor Rendering van Projecten in Pure,
waarbij er een aantal uit de volgende lijst niet zullen werken
omdat ze niet door PF as-is kunnen worden doorgegeven aan Pure Webservices.
Toegestane waarden door Pure (5.20) zijn:

- projectCollaborativePartnersProjectPartnersPortal
- documentExtensionPortal
- detailsPortal
- compact
- workflowableAndLimitedVisibility
- keywordsExtensionPortal
- linkExtensionPortal
- associatesOrganisationsPortal
- expertKeywordGroupsPortal
- keywordsExtensionAsPropertiesPortal
- documentsAttachedPortalRendererNG
- handleNetPortal
- long
- documentLinkExtensionAccessPortal
- documentExtensionWithImagesPortal
- associatesParticipantsClassifiedPortal
- documentAndLinkExtensionPortal
- portal-detailsPortal
- ddp_map_markers
- projectRelationsPortal
- projectCollaborativePartnersJointApplicantsPortal
- keywordGroupsPortal
- documentLinkPortal
- sumOfTotalAwardedAmountProjection
- handleNetMetatagPortal
- ddp_lucene_c
- personsAndOrganisations
- workflowablePortal
- media_link
- allRelationsPortal
- fundingPortal
- projectContentTypePortalRenderer
- UPMProjectDescription
- sumOfTotalAppliedAmountProjection
- ddp_metadata
- compact_fingerprint
- scopusId
- system
- inline
- projectAssociatesParticipantsWithOrganisations
- awards
- expertKeywordGrouspByTypePortal
- short
- userdefinedKeywordsExtensionPortal
- portal-fundingPortal
- associatesExternalOrganisationsPortal
- collaborativePartners

Voorbeelden:

- [${base-url}/organisations/organisation;id=50000115/projects?rendering=short](${base-url}/organisations/organisation;id=50000115/projects?rendering=short) : RSS van Tilburg Law School via de ID
- [${base-url}/organisations/organisation;uuid=d50fd956-2133-47d3-9dc9-cc37ecaa6ba6/projects?rendering=short](${base-url}/organisations/organisation;uuid=d50fd956-2133-47d3-9dc9-cc37ecaa6ba6/projects?rendering=short) : RSS van Tilburg School of Economics and Management

### GET /organisations/organisation;{id=[Id] | uuid=[uuid]}/recent-publications[?ordering=[ordering]][&size=[size]]

RSS van 20 (default) recentste publicaties van de organisatie en alle suborganisaties

Geef dus OF het ID van de organisatie mee als ';id=[id]' OF de UUID als ';uuid=[uuid]'.

De default sortering is afnemende publicatiedatum.
Dat is "-publicationDate" in het lijstje hieronder.
Met een minteken ervoor wordt het een afnemende sortering.
Geeft een term twee of meer dingen aan,
dan geeft een minteken voor de hele term aan dat het afnemend gesorteerd is op het eerste ding
en oplopend voor het tweede.
Met bijvoorbeeld -publicationYearAndAuthor is dat een afnemend publicatiejaar en daarbinnen de naam van de eerste auteur oplopend.
Standaard wordt er een extra sortering toegevoegd op afnemende modificatiedatum.
Deze werkt alleen als het gekozen sorteringscriterium voor bepaalde publicaties gelijk is.

Lijst van orderings (versie 5.21 van Pure):

- publicationYearAndAuthor
- publicationYearAndTypeAndAuthor
- created
- rating
- typeAndAuthor
- type
- title
- typeAndYear
- authorLastName
- publicationYearAndTypeAndTitle
- publicationYear
- modified
- category
- publicationDate
- firstAuthor

Bij de toepassing van een aantal hiervan dekt 'recent-publications' in de URL de lading niet meer.

Bij size geldt 20 als default.
Dat is het maximum aantal publicaties dat er met het verzoek binnen mag komen.
Ga je er minder tonen, vraag er dan minder.
Je mag geen size boven de 100 vragen. 

Voorbeelden:

- [${base-url}/organisations/organisation;id=50000115/recent-publications](${base-url}/organisations/organisation;id=50000115/recent-publications) : RSS van Tilburg Law School via de ID
- [${base-url}/organisations/organisation;uuid=d50fd956-2133-47d3-9dc9-cc37ecaa6ba6/recent-publications?size=12](${base-url}/organisations/organisation;uuid=d50fd956-2133-47d3-9dc9-cc37ecaa6ba6/recent-publications?size=12) : RSS van 12 publicaties Tilburg School of Economics and Management
- [${base-url}/organisations/organisation;id=50000115/recent-publications?ordering=-publicationYearAndTypeAndTitle](${base-url}/organisations/organisation;id=50000115/recent-publications?ordering=-publicationYearAndTypeAndTitle) : RSS van Tilburg Law School via de ID, afwijkende sortering

### GET /persons/select?id=[ANR]...

Experts & Expertise-data van een aantal personen

Geeft de actuele XML van een selectie van personen.
Data komt niet uit de cache.

Werking wijkt af en gebruikt data uit middleware die data uit PGPRD bevat.
Volgende sequence-diagram beschrijft het proces voor 1 persoon.
Bij meerdere personen herhaalt zich communicatie van PF met PGPRD en PureWS.

![UML Sequence Diagram](select.png)

Geef 1 of meer ANR's op via herhaalde '&id=<ANR>' request-parameters.

Voorbeeld: [${base-url}/persons/select?id=178071](${base-url}/persons/select?id=178071) : de XML van Fred Vos

### GET /persons/cache-file-statistics

Statistieken over nieuwste en laatste goedgekeurde XML van Experts & Expertise-data

Geeft application/xml terug.

Voorbeeld: [${base-url}/persons/cache-file-statistics](${base-url}/persons/cache-file-statistics) 

### GET /persons/ee-data-cache-latest-stable

Laatste stabiele (=goedgekeurde) versie van de Experts & Expertise-data

Geeft application/xml terug (groot bestand).

Het bestand wordt periodiek gemaakt en vervangen op initiatief van PF zelf, via een soort cron-proces (Quartz).
Het volgende sequence-diagram beschrijft de werking.

![UML Sequence Diagram](ee-data.png)

Periodiek haalt PF een lijst op met persoons-ID's waarvoor er data in het XML-bestand moet komen.
Per persoon wordt dan de data uit PGPRD opgevraagd en die uit Pure erbij gezet indien de persoon een wetenschapper is.
Al die personen samen vormen een groot XML-bestand dat wordt opgeslagen als 'newest' versie.
Het bestand wordt gecontroleerd op diverse kengetallen en - indien goedgekeurd - gekopieerd naar 'stable'.

Bij dit verzoek wordt de laatst goedgekeurde versie ('stable') van het bestand opgehaald.

Voorbeeld: [${base-url}/persons/ee-data-cache-latest-stable](${base-url}/persons/ee-data-cache-latest-stable) 

### GET /persons/ee-data-cache-newest

Nieuwste versie van de Experts & Expertise-data

Deze is dezelfde als 'latest stable' indien goedgekeurd.
Wanneer niet goedgekeurd, wordt dit bestand niet gekopieerd naar 'latest stable'.

Geeft application/xml terug (groot bestand).

Voorbeeld: [${base-url}/persons/ee-data-cache-newest](${base-url}/persons/ee-data-cache-newest) 

### GET /persons/person;{id=[ID]|mailname=[MAILNAAM]}/uuid

UUID in Pure van wetenschapper, gegeven het id (ANR) of de mailnaam

Mailnaam is case-insensitive.

Voorbeeld: [${base-url}/persons/person;mailname=Emile.Aarts/uuid](${base-url}/persons/person;mailname=Emile.Aarts/uuid) : UUID van Emile Aarts

Vanwege privacy kan er geen voorbeeld worden gegeven met het id (ANR).

### GET /publishers/publisher;{name=[name]}/recent-publications[?ordering=[ordering]]

RSS van 20 recentste publicaties van een uitgever,
gesorteerd op afnemende publicatiedatum

Geef de naam, letterlijk van de uitgeverij mee als ';name=[name]'.

Optioneel afwijkende ordering gebruiken.
Zie de opties bij organisaties.

Voorbeeld:

- [${base-url}/publishers/publisher;name=Tilburg%20University%20Press/recent-publications](${base-url}/publishers/publisher;name=Tilburg%20University%20Press/recent-publications) : RSS van Tilburg University Press

### GET /series?series=[NAAM-SERIES]&publication-year=[JAAR]&document-type={thesisdoc|discussionpaper}

Series van een jaar compleet als RSS

Een RSS feed van publicaties van een zekere serie voor een jaar.
Publicaties gesorteerd op afnemend volume.

Request parameter 'series' is verplicht; voor de andere twee gelden defaults, maar geef deze toch liever op om voor anderen expliciet te zijn over wat je vraagt.

Request parameter value voor 'series' moet letterlijk overeenstemmen met die vastgelegd in Pure, maar is wel case insensitive.

Request parameter value voor 'publication-year' is het jaar in vier cijfers of een delta ten opzichte van het huidige jaar, wanneer het vanaf -10 t/m +10 is.
Dus: 'publication-year=2019' is in 2019 hetzelfde als 'publication-year=0'.
In 2019 betekent 'publication-year=-1' dus 2018 en 'publication-year=1' dus 2020.
Default is 0, dus geef je parameter 'publication-year' niet op, dan wordt het het huidige jaar.

Request parameter value voor 'document-type' is een van de opties zoals - door pipe-tekens gescheiden - bij URL beschreven.
Elke andere waarde is niet correct.
De programmatuur vertaalt deze verkorte namen naar de lange URI die Pure intern aanhoudt voor document type.
Hier geldt de eerstgenoemde in de URL-beschrijving als default.
Maak van de default-optie liever geen gebruik, omdat anderen jouw URL ook moeten begrijpen.

Dit verzoek leidt in de regel tot meerdere verzoeken aan Pure, waarbij veel meer wordt opgehaald dan nodig is.
Achteraf wordt er dan gefilterd.
Daardoor is dit verzoek relatief traag met antwoorden.
Indien mogelijk, dan de frequentie van opvragen beperken; bijvoorbeeld niet elke 5 minuten hernieuwd opvragen als een pagina open blijft staan.

Voorbeelden:

- [${base-url}/series?series=CentER%20Discussion%20Paper&publication-year=2014&document-type=discussionpaper](${base-url}/series?series=CentER%20Discussion%20Paper&publication-year=2014&document-type=discussionpaper) : CentER Discussion Paper series van 2014
  
- [${base-url}/series?series=CentER%20Dissertation%20Series&publication-year=2016&document-type=thesisdoc](${base-url}/series?series=CentER%20Dissertation%20Series&publication-year=2016&document-type=thesisdoc) : CentER Dissertation Series van 2016

- [${base-url}/series?series=CentER%20Dissertation%20Series&publication-year=0&document-type=thesisdoc](${base-url}/series?series=CentER%20Dissertation%20Series&publication-year=0&document-type=thesisdoc) : CentER Dissertation Series van dit jaar

- [${base-url}/series?series=TiCC%20Ph.D.%20Series&publication-year=2017&document-type=thesisdoc](${base-url}/series?series=TiCC%20Ph.D.%20Series&publication-year=2017&document-type=thesisdoc) : TiCC Ph.D. Series van 2017

### GET /status

Status van PF

Kan zowel text/html als application/xml geven.
Applicaties kunnen aangeven dat ze application/xml willen.

Voorbeeld: [${base-url}/status](${base-url}/status)

### GET /theses?publication-year=[JAAR]&publication-year-start=[JAAR]&publication-year-end=[JAAR]

RSS-feed van proefschriften van een jaar of een reeks jaren, gesorteerd op afnemende publicatiedatum

Kies voor 'publication-year' OF voor 'publication-year-start' en/of 'publication-year-end'.
Je kan niet voor beide systemen kiezen.

Request parameter value voor 'publication-year', 'publication-year-start'
en publication-year-end is het jaar in vier cijfers
of een delta ten opzichte van het huidige jaar.
Die delta wordt alleen gebruikt wanneer het vanaf -10 t/m +10 is.
Dus: 'publication-year-start=2026' is in 2026 hetzelfde als 'publication-year-start=0'.
In 2026 betekent 'publication-year-end=-1' dus 2025 en 'publication-year-end=1' dus 2027.
Default is publication-year=0,
dus geef je geen parameters 'publication-year', 'publication-year-start' of
'publication-year-end' op,
dan wordt het in de regel alles van dit jaar.

Dit verzoek leidt in de regel tot meerdere verzoeken aan Pure.
Daardoor is dit verzoek relatief traag met antwoorden.
Indien mogelijk, dan de frequentie van opvragen beperken; bijvoorbeeld niet elke 5 minuten hernieuwd opvragen als een pagina open blijft staan.

Voorbeelden:

- [${base-url}/theses?publication-year-start=2021&publication-year-end=2022](${base-url}/theses?publication-year-start=2020&publication-year-end=2021) : Proefschriften uit 2021 en 2022 (max 100)
  
- [${base-url}/theses?size=10](${base-url}/theses?size=10) : Maximaal 10 recente proefschriften van dit jaar
  
## Verder

### Release notes

Deze vind je [hier](release-notes).

### Roadmap

Deze vind je [hier](roadmap).
